<template>
  <div class="logchain-card">
    <div class="logchain-card__line"></div>
    <div class="logchain-card__points">
      <div class="logchain-card__point logchain-card__point--start">
        <i :class="['icon city-sm', startPoint.locationTypeIcon.toLowerCase()]" />
        {{ startPoint.address.label }}
      </div>
      <template v-if="inBetweenPoints && inBetweenPoints.length">
        <div
          v-for="point in inBetweenPoints"
          :key="point.uuid"
          :class="['logchain-card__point', point.address.label === 'Новая локация' ? 'logchain-card__point--new' : '']"
        >
          <i :class="['icon', point.locationTypeIcon.toLowerCase(), point.isMain ? 'main' : '']" />
          {{ point.address.label }}
        </div>
      </template>
      <div class="logchain-card__point logchain-card__point--end">
        <i :class="['icon city-sm', endPoint.locationTypeIcon.toLowerCase()]" />
        {{ endPoint.address.label }}
      </div>
    </div>
    <div class="logchain-card__inbetween">
      <div
        :class="[
          'logchain-card__inbetween-point',
          point.services.length ? '' : 'logchain-card__inbetween-point--error',
        ]"
        v-for="point in servicePoints"
        :key="point.uuid"
      >
        <div class="logchain-card__inbetween-point-info">
          <i
            :class="['icon', $options.iconsMap[point.resourceClassUuid], point.isMain ? 'main' : '']"
            v-if="point.services.length"
          ></i>
          <div class="logchain-card__service-label">
            <template v-if="point.services.length">
              услуг: {{ point.services.length }}
            </template>
            <template v-else>
              + услуги
            </template>
          </div>
          <i class="icon checked" v-if="point.isMain"></i>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "logchainRouteCard",

  props: {
    startPoint: {
      type: Object,
      required: true
    },

    endPoint: {
      type: Object,
      required: true
    },

    inBetweenPoints: {
      type: Array,
      default: () => []
    },

    servicePoints: {
      type: Array,
      default: () => []
    },

    serviceCategoryIcon: {
      type: String,
      required: true
    }
  },

  iconsMap: {
    "e7519b46-faf4-11e9-8f0b-362b9e155667": "truck",
    "e7519ee8-faf4-11e9-8f0b-362b9e155667": "container",
    "e7519d9e-faf4-11e9-8f0b-362b9e155667": "train-sm",
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.logchain-card {
  padding: 55px 37px 30px;
  box-shadow: 0px 4px 16px rgba(0, 75, 200, 0.2);
  border-radius: 4px;
}

.logchain-card__line {
  position: relative;
  height: 2px;
  border-top: 2px dotted $cornflower-craiola;

  // &:before,
  // &:after {
  //   content: '';
  //   width: 6px;
  //   height: 6px;
  //   background: #B0C6E7;
  //   position: absolute;
  //   top: -4px;
  //   border-radius: 50%;
  // }

  // &:before {
  //   left: 0;
  // }

  // &:after {
  //   right: 0;
  // }
}

.logchain-card__points {
  display: flex;
  justify-content: space-between;
  width: 100%;
  margin-top: 8px;
  @include font-mixin(10px, 12px, 600, $shale-gray, 0.6px, uppercase);

  i {
    margin-bottom: 5px;
    font-size: 17px;
    color: $color-grey-border;
  }
}

.logchain-card__point {
  position: relative;
  display: flex;
  flex-grow: 1;
  flex-direction: column;
  max-width: 130px;
  align-items: center;
  text-align: center;

  &:after {
    content: "";
    width: 6px;
    height: 6px;
    background: #b0c6e7;
    position: absolute;
    top: -12px;
    left: 50%;
    margin-left: -3px;
    border-radius: 50%;
  }

  &--new {
    color: $color-error;
  }
}

.logchain-card__point--start {
  align-items: flex-start;
  left: -8px;
  text-align: left;

  &:after {
    margin-left: 0;
    left: 0;
  }
}

.logchain-card__point--end {
  align-items: flex-end;
  right: -8px;
  text-align: right;

  &:after {
    margin-left: 0;
    left: auto;
    right: 0;
  }
}

.logchain-card__inbetween {
  position: absolute;
  width: calc(100% - 74px);
  height: 50px;
  left: 37px;
  top: 49px;
  display: flex;
}

.logchain-card__inbetween-point {
  display: flex;
  flex-grow: 1;
  justify-content: center;

  &--error {
    .logchain-card__service-label {
      color: $color-error;
    }
  }
}

.logchain-card__inbetween-point-info {
  position: relative;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  i {
    position: absolute;
    left: 50%;
    top: 0;
    transform: translateX(-50%);
    color: $color-blue-navy-blue;
    font-size: 16px;
    font-weight: bold;

    &.main {
      color: $color-green-light;
    }

    &:last-child {
      top: auto;
      bottom: -10px;
    }
  }

  .container {
    width: auto;
  }
}

.logchain-card__service-label {
  padding: 4px 14px 2px 10px;
  margin: 15px 0 7px;
  border: 1px solid $blue-blue-hoarfrost;
  border-radius: 5px;
  background: #fff;
  @include font-mixin(11px, 8px, 400, $color-blue-navy-blue, 0.2px, uppercase);
}

.container {
  width: auto;
}
</style>
